// WordHTML.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "WordHTML.h"
#include "MainFrm.h"

#include "WordHTMLDoc.h"
#include "WordHTMLView.h"
#include ".\wordhtml.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWordHTMLApp
CString GetModuleDirectory();
CString ExtractFile(CString path);
CString ExtractDirectory(CString path);

BEGIN_MESSAGE_MAP(CWordHTMLApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()


// CWordHTMLApp construction

CWordHTMLApp::CWordHTMLApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	deletePathArray.RemoveAll();

	m_opt_includeTOC = 0;
	tocTitle = "Table of Contents";
	tocFormat = 1;
	memset(&m_opt_TOCFont,0,sizeof(LOGFONT));
	m_opt_TOCFont.lfHeight = 12;
	strcpy(m_opt_TOCFont.lfFaceName,"Verdana");

	toc_bullets = 1;

}


// The one and only CWordHTMLApp object

CWordHTMLApp theApp;

// CWordHTMLApp initialization

BOOL CWordHTMLApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CWordHTMLDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CWordHTMLView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The one and only window has been initialized, so show and update it
	
	
	
	m_opt_TOCFont.lfHeight = GetProfileInt( "Settings", "tocFontHeight", 12);
	int fontStyle = GetProfileInt( "Settings", "tocFontStyle", 0);

	//CString xx;
	//xx.Format("%d",fontStyle);
	//AfxMessageBox(xx);

	if (fontStyle & 1)
		m_opt_TOCFont.lfWeight = 800;
	else
		m_opt_TOCFont.lfWeight = 400;

	if (fontStyle & 2)
		m_opt_TOCFont.lfItalic = TRUE;
	else
		m_opt_TOCFont.lfItalic = FALSE;

	CString fontface = GetProfileString( "Settings", "tocFontFace", "Verdana");
	strcpy(m_opt_TOCFont.lfFaceName,LPCTSTR(fontface));


	tocFormat = GetProfileInt( "Settings", "tocFormat", 1);
	toc_bullets = GetProfileInt( "Settings", "includeTOC", 1);
	m_opt_includeTOC = GetProfileInt( "Settings", "includeTOC", 0);
	tocTitle = GetProfileString( "Settings", "tocTitle", "Table of Contents");


	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	m_pMainWnd->DragAcceptFiles(1);
	
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButton1();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()

// App command to run the dialog
void CWordHTMLApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CWordHTMLApp message handlers





BOOL CWordHTMLApp::OnIdle(LONG lCount)
{
	// TODO: Add your specialized code here and/or call the base class
	if (m_pMainWnd)
	{

		if (((CMainFrame*) m_pMainWnd)->accessingBuffer)
			return CWinApp::OnIdle(lCount);			


		int cc = ((CMainFrame*) m_pMainWnd)->fileArray.GetCount();

		
		if (cc>0)
		{		

			((CMainFrame*) m_pMainWnd)->accessingBuffer = 1;

			//CString fstr;
			//fstr.Format("%d",cc);
			//AfxMessageBox(fstr);

			int zz = deletePathArray.GetCount();
			for (int i=0;i<zz;i++)
			{								
				CString pathx = deletePathArray[i];
				//AfxMessageBox(pathx);
				DeleteFile(pathx);
			}
			deletePathArray.RemoveAll();
			

			m_pMainWnd->DragAcceptFiles(0);
			CString directoryx = GetModuleDirectory();
			srand( (unsigned)time( NULL ) );

			for (int i=0;i<cc;i++)
			{
			
					CString filename = ((CMainFrame*) m_pMainWnd)->fileArray[i];
					CString needBullets ="0";
				

					CString pathx = directoryx + "\\wsscript.vbs";

					CString newFileName = ExtractFile(filename);
					CString newPath = ExtractDirectory(filename);					
					CString newpp = filename + "_HTML";
					int rx = CreateDirectory(newpp,NULL);
					//if (rx==FALSE)

					CString outFile = newpp  + "\\" + newFileName + ".htm";					
					//CString outFile = filename + ".htm";					

					//CString tocFile = filename + ".toc.htm";
					//tocFile = ExtractFile(tocFile);
					
					CString tocFile = tocTitle;

					//tocFile.MakeLower();
					//tocFile.Replace(".doc","");
					//tocFile = tocFile + ".htm";
					CString tocString = "0";
					if (m_opt_includeTOC)
						tocString = "1";						
					CString fontName = m_opt_TOCFont.lfFaceName;
					CString fontSize;
					fontSize.Format("%d",abs(m_opt_TOCFont.lfHeight*3/4));

					int stylex = 0;  
					CString fontStyle;
					if (m_opt_TOCFont.lfWeight>600)
						stylex |= 1;
					if (m_opt_TOCFont.lfItalic)
						stylex |= 2;
					fontStyle.Format("%d",stylex);

					CString tocFormatStr = "1";
					if (tocFormat==0)
					{
						tocFormatStr = "1";
					}
					else if (tocFormat==1)
					{
						tocFormatStr = "2";
					}
					else if (tocFormat==2)
					{
						tocFormatStr = "3";
					}
					else if (tocFormat==3)
					{
						tocFormatStr = "5";
					}
					else if (tocFormat==4)
					{
						tocFormatStr = "4";
					}
					else if (tocFormat==5)
					{
						tocFormatStr = "6";
					}
					else if (tocFormat==6)
					{
						tocFormatStr = "0";
					}

					if (toc_bullets)
						needBullets = "1";

					pathx = "cscript \"" + pathx + "\" \"" + filename + "\" \""  + outFile + "\" " +  tocString + " \"" + tocFile + "\" \"" + fontName + "\" " + fontSize + " " + fontStyle + " " + tocFormatStr + " " + needBullets;		
					//AfxMessageBox(pathx);
					
					
					/*
					int val2 = rand();
					int val = (unsigned)time( NULL );
					CString wext; 
					CString wname;
					
					//Set Modified Script
					wname = directoryx + "\\wsscript";								
					wext.Format("%d%d.vbs",val,val2);
					wname = wname  + wext;

					CString templateStr = ScriptMod(filename);
					FILE* fpw = fopen(wname,"wb");
					if (fpw)
					{
						int len = templateStr.GetLength();
						fwrite(templateStr,len ,1,fpw);
						fclose(fpw);
					}

					pathx = "cscript \"" + wname + "\"";				
					*/

					if ((toc_bullets) && (m_opt_includeTOC))
					{	
						//WinExec(pathx,SW_HIDE);
						
						//restore
						WinExecWait( pathx );
										
						//deletePathArray.Add(pathx);
						Sleep(200);

						ProcessHTML( outFile );

						//CString pathy;
						//pathy = directoryx + "\\htmlproc.exe " + "\"" + filename + "\"";

						//AfxMessageBox(pathy);	
						//WinExecWait( pathy );
					}
					else
						WinExec(pathx,SW_HIDE);



				
			}			

			((CMainFrame*) m_pMainWnd)->fileArray.RemoveAll();
			((CMainFrame*) m_pMainWnd)->accessingBuffer = 0;

			/*
			CWordHTMLView* whv = (CWordHTMLView*)  ((CMainFrame*) m_pMainWnd)->GetActiveView();
			if (whv)
			{
				CString directoryX = GetModuleDirectory();
				CString pathz = directoryX + "\\initial.htm";	
				whv->goPath = pathz;
				whv->PostMessage(WM_USER_NAVIGATE,0,0);
			
			}
			*/

		}
		else
			m_pMainWnd->DragAcceptFiles(1);

	}

	return CWinApp::OnIdle(lCount);
}


CString CWordHTMLApp::ScriptMod(CString inFile)
{
	CString outFile = inFile + ".htm";

	inFile = "\"" + inFile + "\"";
	outFile = "\"" + outFile + "\"";

	CString directoryx = GetModuleDirectory();
	CString pathx = directoryx + "\\wsscript.vbs";

	TCHAR buffer[27648]; //27K		
	FILE* fp = fopen(pathx,"rb");
	if (fp)
	{		
		int rr = fread(buffer,1,27648,fp);			
		if (rr<27648)
			buffer[rr] =0 ;

		fclose(fp);

	}
	else
		return _T("");	

	CString templateStr = buffer;
	templateStr.Replace("<OPENFILE>",inFile);
	templateStr.Replace("<SAVEFILE>",outFile);
	
	return templateStr;

}

int CWordHTMLApp::ExitInstance()
{
	/*
	// TODO: Add your specialized code here and/or call the base class
	int cc = deletePathArray.GetCount();
	for (int i=0;i<cc;i++)
	{								
		CString pathx = deletePathArray[i];	
		//AfxMessageBox(pathx);
		//DeleteFile(pathx);
		MoveFile(pathx,pathx+".txt");
	}
	deletePathArray.RemoveAll();
	*/


	WriteProfileInt( "Settings", "tocFontHeight", m_opt_TOCFont.lfHeight);
	int fontStyle = 0;
	
	if (m_opt_TOCFont.lfWeight>600)
		fontStyle |= 1;	
	
	if (m_opt_TOCFont.lfItalic)
		fontStyle |= 2;	

	WriteProfileInt( "Settings", "tocFontStyle", fontStyle);
	WriteProfileString( "Settings", "tocFontFace", m_opt_TOCFont.lfFaceName);


	WriteProfileInt( "Settings", "tocFormat", tocFormat);
	WriteProfileInt( "Settings", "includeTOC", toc_bullets);
	WriteProfileInt( "Settings", "includeTOC", m_opt_includeTOC);
	WriteProfileString( "Settings", "tocTitle", tocTitle);


	return CWinApp::ExitInstance();
}

void CAboutDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	CString  remotePath;    
	remotePath = "http://www.technoriversoft.com";
	HINSTANCE hRun = ShellExecute (GetSafeHwnd (), _T ("open"), remotePath, NULL, NULL, SW_SHOW);	

}


CString ExtractFile(CString path)
{
	CString retPath ="TOC.htm";
	CString modPath;
	modPath = path;
	int lenx = modPath.GetLength();
	int fval = modPath.ReverseFind('\\');	

	int ext = lenx - fval - 1;
	if (ext>0)
		retPath=modPath.Right(ext);
	
	return retPath;	

}

void CWordHTMLApp::WinExecWait( CString str )
{
    STARTUPINFO si;
    PROCESS_INFORMATION pi;

    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
	si.dwFlags |= STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;


    ZeroMemory( &pi, sizeof(pi) );

    // Start the child process. 
    if( !CreateProcess( NULL, // No module name (use command line). 
        (char*) LPCTSTR(str), // Command line. 
        NULL,             // Process handle not inheritable. 
        NULL,             // Thread handle not inheritable. 
        FALSE,            // Set handle inheritance to FALSE. 
        HIGH_PRIORITY_CLASS,                // No creation flags. 
        NULL,             // Use parent's environment block. 
        NULL,             // Use parent's starting directory. 
        &si,              // Pointer to STARTUPINFO structure.
        &pi )             // Pointer to PROCESS_INFORMATION structure.
    ) 
    {
        //ErrorExit( "CreateProcess failed." );
		return;
    }

    // Wait until child process exits.
    WaitForSingleObject( pi.hProcess, INFINITE );
	//WaitForSingleObject( pi.hProcess, 6000);

    // Close process and thread handles. 
    CloseHandle( pi.hProcess );
    CloseHandle( pi.hThread );
}


void CWordHTMLApp::ProcessHTML( CString fileName )
{

	if (fileName == _T(""))
		return;

	 CString dirx = ExtractDirectory(fileName);
	 CString dirthis = GetModuleDirectory();


	 //restore
	 //AfxMessageBox(fileName);


	 CString newName,oldName;
	 int val = (unsigned)time( NULL );
	 newName.Format("%d",val);

	 newName = fileName + "." + newName  + ".doc";
	 oldName = fileName;


	 //Assume here that the presence of the .doc.htm implies that its table of contents is completed

	 //Wait for main file .doc.htm to be ready	 
	 int maxcount = 600; //60 seconds max wait
	 int count = 0;
	 int fstatus = MoveFile(oldName,newName);
	 while ((count<maxcount) && (fstatus==FALSE))
	 {
		 fstatus = MoveFile(oldName,newName);
		 Sleep(100);

	 }

	 if (fstatus==FALSE)
		 return;

	 MoveFile(newName,oldName); //revert to original name


	//Find TOC File
	CString fullStrX = _T("");
	char bufferX[32768];
	CFile htmlFileX(fileName,CFile::modeRead | CFile::typeBinary);
	int retX = htmlFileX.Read(bufferX,32768);
	if ((retX>=0) && (retX<32768))
		bufferX[retX]=0;
	while (retX>0)
	{		
		CString tempStrX;
		tempStrX = bufferX;

		fullStrX += tempStrX;
		
		retX = htmlFileX.Read(bufferX,32768);
		if ((retX>=0) && (retX<32768))
			bufferX[retX]=0;

	}
	htmlFileX.Close();

	int extracted = 0;

	CString tocFileStrX;
	tocFileStrX= "<frame name=TOC src=\"";
	int llen = tocFileStrX.GetLength();	
	int findv = fullStrX.Find(tocFileStrX,0);
	if (findv>=0)
	{
		

		CString extstr;
		int stx = findv + llen;

		int findv2 = fullStrX.Find("\"",stx+1);
		extstr = fullStrX.Mid(stx,findv2-stx);
		extstr.Replace("%20"," ");

		//fileName.Format("%d %d %d",stx,findv2,findv2-stx);
		//fileName.Format("%d",extstr.GetLength());
		//AfxMessageBox(fileName);
		//AfxMessageBox(extstr);

		if (findv2-stx>0)
		{		
			fileName = extstr;
			extracted = 1;

		}

	}

	if (extracted == 0)
	{
			CString tocFileStrX;
			tocFileStrX= "<frame name=TOC src=";
			int llen = tocFileStrX.GetLength();	
			int findv = fullStrX.Find(tocFileStrX,0);
			if (findv>=0)
			{
				

				CString extstr;
				int stx = findv + llen;

				int findv2 = fullStrX.Find(" ",stx+1);
				extstr = fullStrX.Mid(stx,findv2-stx);
				extstr.Replace("%20"," ");

				//fileName.Format("%d %d %d",stx,findv2,findv2-stx);
				//AfxMessageBox(fileName);
				//AfxMessageBox(extstr);

				if (findv2-stx>0)
				{		
					fileName = extstr;
					extracted = 1;

				}

			}

	}


	if (extracted == 0)
	{
		return;

	}
	
	CString bulletFile = dirthis + "\\bullet.gif";
	CString mainFile = dirthis + "\\main.gif";
	CString bulletFileDest = dirx + "\\bullet.gif";
	CString mainFileDest = dirx + "\\main.gif";
	CopyFile(bulletFile,bulletFileDest,TRUE);
	CopyFile(mainFile,mainFileDest,TRUE);


	fileName= dirx + "\\" + fileName;

	
	//restore
	//AfxMessageBox(fileName);


	CString fullStr = _T("");
	char buffer[32768];
	//CFile htmlFile(renamedFile,CFile::modeRead | CFile::typeBinary);
	CFile htmlFile(fileName,CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone);
	//CFile htmlFile(fileName,CFile::modeRead  | CFile::shareDenyNone);
	int ret = htmlFile.Read(buffer,32768);
	if ((ret>=0) && (ret<32768))
		buffer[ret]=0;
	while (ret>0)
	{		
		CString tempStr;
		tempStr = buffer;

		fullStr += tempStr;
		
		ret = htmlFile.Read(buffer,32768);
		if ((ret>=0) && (ret<32768))
			buffer[ret]=0;

	}
	htmlFile.Close();

	int insertLen;
	int insertMainLen;
	CString insertStr;
	insertStr = "<img src=\"bullet.gif\">";

	CString insertStrMain;
	insertStrMain = "<img src=\"main.gif\">";

	insertLen = insertStr.GetLength();
	insertMainLen = insertStrMain.GetLength();

	
	CString tocStr;
	tocStr= "<p class=MsoToc";
	int llx = tocStr.GetLength();
	int currentState = 0;
	int findw = fullStr.Find(tocStr,0);
	if (findw>=0)
	{

		int xnext = fullStr[findw+llx];
		
		
		//CString xstr;
		//xstr.Format("%c",xnext);
		//AfxMessageBox(xstr);

		if (xnext=='1')
			currentState = 1;

	}
	findw++;


	 

	int findx  = fullStr.Find("href=",0);
	while (findx>=0)
	{

		int inspos = findx;
		for (int i=inspos;i>inspos-10;i--)
		{		
			if (fullStr[i]=='<')
				inspos = i;

		}

		
		//restore
		//CString ccs;
		//ccs.Format("CS %d %d %d %d" ,currentState, i, inspos,findx);
		//AfxMessageBox(ccs);
		
			
		if ((inspos<findx) && (findx!=inspos-10))
		{


			//found '<'
			if (currentState == 1)
				fullStr.Insert(inspos,insertStrMain);
			else		
				fullStr.Insert(inspos,insertStr);		


			//restore
			//CString xstr;
			//xstr.Format("findx %d",findx);
			//AfxMessageBox(xstr);

			currentState = 0;
			findw = fullStr.Find(tocStr,findw);
			if (findw>=0)
			{
				int xnext = fullStr[findw+llx];
				
				if (xnext=='1')
					currentState = 1;
			}
			findw++;
			
			

		}
		findx  = fullStr.Find("href=",findx);
		findx++;
		findx  = fullStr.Find("href=",findx);

	}
	
	int lenx = fullStr.GetLength();

	CFile htmlFileOut(fileName,CFile::modeWrite | CFile::typeBinary);
	htmlFileOut.Write(LPCTSTR(fullStr),lenx);
	htmlFileOut.Close();

	//DeleteFile(renamedFile);


	return;

}



CString ExtractDirectory(CString path)
{
	CString modPath;
	modPath = path;
	int fval = modPath.ReverseFind('\\');	
	CString retPath=modPath.Left(fval);
	
	return retPath;	

}